Attribute VB_Name = "APIError"
Option Explicit
Private Const FORMAT_MESSAGE_FROM_SYSTEM    As Long = &H1000&
Private Const FORMAT_MESSAGE_IGNORE_INSERTS As Long = &H200&
Private Const FORMAT_MESSAGE_MAX_WIDTH_MASK As Long = &HFF&
Private Const LANG_USER_DEFAULT             As Long = &H400&
Private Declare Function FormatMessage _
    Lib "kernel32" Alias "FormatMessageA" ( _
    ByVal dwFlags As Long, _
    ByRef lpSource As Any, _
    ByVal dwMessageId As Long, _
    ByVal dwLanguageId As Long, _
    ByVal lpBuffer As String, _
    ByVal nSize As Long, _
    ByRef Arguments As Long _
) As Long
' --- Code

Public Function APIErrorDescription(ByVal ErrLastDllError As Long) As String
    ' Liefert die Klartextbeschreibung zu einer API Fehlernummer, die
    ' unter Visual Basic ber Err.LastDllError ermittelt wurde.
    ' HINWEIS: Die API-Funktion GetLastError ist fr Visual Basic tabu!
    Dim sBuffer    As String  ' String fr die Rckgabe des Fehlertexts
    Dim lBufferLen As Long    ' Lnge des reservierten Strings
    ' Stringbuffer fr die Rckgabe reservieren
    sBuffer = Space$(1024)
    ' Fehlernummer in einen Fehlertext wandeln
    lBufferLen = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM Or _
                               FORMAT_MESSAGE_MAX_WIDTH_MASK Or _
                               FORMAT_MESSAGE_IGNORE_INSERTS, _
                               ByVal 0&, ErrLastDllError, _
                               LANG_USER_DEFAULT, _
                               sBuffer, Len(sBuffer), 0)
    If lBufferLen > 0 Then
        ' Fehler wurde identifiziert, der Fehlertext liegt vor
        APIErrorDescription = Left$(sBuffer, lBufferLen)
    Else
        ' Der Fehlertext konnte nicht ermittelt werden
        APIErrorDescription = "Unbekannter Fehler: &H" & Hex$(ErrLastDllError)
    End If
End Function


